extends CharacterBody3D

@onready var agent = $NavigationAgent3D

func set_destination(destination : Vector3):
	agent.set_target_position(destination)

func _physics_process(delta):
	var desired_velocity = Vector3.ZERO
	
	if not agent.is_navigation_finished():
		var move_direction = (agent.get_next_path_position() - global_position).normalized()
		desired_velocity = move_direction * 5
		
		var desired_angle = move_direction.signed_angle_to(Vector3.RIGHT, Vector3.DOWN)
		rotation.y = lerp_angle(rotation.y, desired_angle, delta * 5)
	
	velocity = lerp(velocity, desired_velocity, delta * 10)
	move_and_slide()
